//+------------------------------------------------------------------+
//|                                                    TrendLabs.mq4 |
//|                               Copyright  2008, NonDisclosure007 |
//|                                         http://www.nolinkyet.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, NonDisclosure007"
#property link      "http://www.metaquotes.net"




#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1  Goldenrod
#property indicator_width1  3
#property indicator_level1  3
#property indicator_level2 -3
#property indicator_level3  0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor Magenta
#property indicator_minimum -4
#property indicator_maximum 4




extern string TimeFrame       = "Current time frame";
extern int    highlevel       = 3;
extern int    lowlevel        = -3;
extern bool   Interpolate     = true;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert.wav";



double Buffer[];
double trend[];


string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;




int init()
  {
   IndicatorBuffers(2);
   SetIndexBuffer(0,Buffer);
   SetIndexBuffer(1,trend);
   
   
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
  IndicatorShortName(timeFrameToString(timeFrame) + " TrendLabs ");
   return(0);
  }

int deinit(){ return(0);}




int start()
  {
  int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
        limit=MathMin(Bars-counted_bars,Bars-1);
        if (returnBars)  { Buffer[0] = limit+1; return(0); } 
         
         
         
      if (calculateValue || timeFrame==Period())
      { 
  
  
      for(i=limit; i >= 0; i--)
      {
      Buffer[i] =
      funcGetAbsoluteStrength(i)+
      iCustom(NULL,0,"LabTrend1",3,1,1,0,6,i)+
      iCustom(NULL,0,"LabTrend2",3,2,9,50,0,0,4,i)+
      iCustom(NULL,0,"LabTrend3",3,2,9,7,i)+
      iRSI(NULL,0,14,0,i)/100;
   
      if (Buffer[i] > highlevel && Buffer[i+1] <= highlevel) trend[i] = 1;   
      if (Buffer[i] <  lowlevel && Buffer[i+1] >= lowlevel)  trend[i] = -1; 
      }
      manageAlerts();
   
   return(0);
}
limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
   int y = iBarShift(NULL,timeFrame,Time[i]);
  
   
   Buffer[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",highlevel,lowlevel,0,y);
   trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",highlevel,lowlevel,1,y);
   
   
   if (Buffer[i] > highlevel && Buffer[i+1] <= highlevel) trend[i] = 1;   
   if (Buffer[i] <  lowlevel && Buffer[i+1] >= lowlevel)  trend[i] = -1; 
      
   manageAlerts();
   
   
   
  if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
  if (!Interpolate) continue;
   
   
  
     datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         for(int k = 1; k < n; k++)
         {
            Buffer[i+k] = Buffer[i] + (Buffer[i+n] - Buffer[i])*k/n;
            
            
         }             
   }
   
    manageAlerts();
   
   //
   //
   //
   //
   //
   
   return(0);
}


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}



double funcGetAbsoluteStrength(int Current)
{
      double Bulls    = iCustom(NULL,0,"AbsoluteStrengthForEA",0,Current);
      double Bears    = iCustom(NULL,0,"AbsoluteStrengthForEA",1,Current);

   
   if (Bulls == 1) return(1);
   if (Bears == 2) return(-1);
   return(0);
}

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TrendLab changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TrendLab "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

